#
# Name: sample-29.py
#

# ----- Functional Programmong with Python -----

# Pure function

def fact(n):
    if n <= 0:
        return 1
    return n * fact(n-1)

# Has no side effects

print "-----> Concept of Pure Functions"

n = 5

print "n (before) = ", n
print "fact(5) = ", fact(n)
print "n (after) = ", n

# First class object

print "-----> Concept of First Class Objects"

def func_obj(n):
    print "func_obj invoked with n = ", n
    return

fn = func_obj

fn(5)

# Higer order function(s)

print "-----> Concept of Higher Order Functions"

def fn(arg):
    print "Invoked fn with arg: ", arg
    return

def hofn1(fn, arg):
    print "Higher order function hofn1 called with arg: ", arg
    fn(arg)
    return

def hofn2():
    print "Invoked hofn2"
    return fn

def filt_fn(n):
    return n % 3 == 0

def map_fn(n):
    return n*2

def red_fn(a, b):
    return a * b

hofn1(fn, 10)

myfn = hofn2()

myfn(15)

lst1 = [1, 2, 3, 4, 5, 6, 7, 8, 9]

# Demostrate filter

print "List (before filter): ", lst1

lst2 = filter(filt_fn, lst1)

print "List (after filter): ", lst2

# Demostrate map

lst3 = map(map_fn, lst1)

print "List (after map): ", lst3

# Demostrate reduce

val = reduce(red_fn, lst1)

print "Value (afetr reduce): ", val

# Lambda function(s)

print "-----> Concept of Lambdas"

print "List (before lambda filter): ", lst1

lst2 = filter(lambda n: n % 2 == 0, lst1)

print "List (after lambda filter): ", lst2

lst3 = map(lambda n: n ** 3, lst1)

print "List (after lambda map): ", lst3

val = reduce(lambda a,b: a + b, lst1)

print "Value (afetr lambda reduce): ", val

# Closure function(s)

print "-----> Concept of Closures"

def div_by(n):
    def inner(m):
        return m / n
    return inner

div_by_2 = div_by(2)

print "Invoke div_by_2(24) = ", div_by_2(24)

# List comprehensions

print "-----> Concept of List Comprehension"

lst4 = range(1, 11)

print "lst4 = ", lst4

lst5 = [(n+1) for n in lst4]

print "lst5 = ", lst5

lst6 = [n for n in lst4 if (n % 2) == 0]

print "lst6 = ", lst6

lst7 = ['A', 'B']
lst8 = [1, 2]

lst9 = [(x, y) for x in lst7 for y in lst8]

print "lst9 = ", lst9
