#
# Name: sample-30.py
#

# ----- Miscellaneous concepts in Python -----

# Positional arguments

def myfunc1(*args):
    print "Invoked myfunc1() with args:"
    for a in args:
        print "\t{0}".format(a)
    return

myfunc1(1, 2, 3)

myfunc1('A', 'B', 'C', 'D', 'E')

# Keyword arguments

def myfunc2(**kwargs):
    print "Invoked myfunc2() with keywork args:"
    for key in kwargs:
        print "\t{0} = {1}".format(key, kwargs[key])
    return

myfunc2(name='PYTHON', type='LANG', value=3)

myfunc2(a=1, b=2, c=3, d=4, e=5)

# Pre-defined __dict__ attribute

class myclass1():
    def __init__(self):
        self.name = ""
        self.price = 0.0

    def get_name(self):
        return self.name

    def set_name(self, name):
        self.name = name
        return

    def get_price(self):
        return self.price

    def set_price(self, price):
        self.price = price
        return

obj1 = myclass1()
obj1.set_name("Python")
obj1.set_price(9.99)

print "obj1.get_name() = ", obj1.get_name()
print "obj1.__dict__ = ", obj1.__dict__
